package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[UserDGTheme] 数据对象
 */
@TableName(value = "T_SRFUSERDGTHEME",resultMap = "UserDGThemeResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class UserDGTheme extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String datagridid;
    private String dgthememodel;
    private String personid;
    private String projectid;
    private String reserver;
    private String reserver2;
    private String reserver3;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "userdgthemeid",type=IdType.UUID)//指定主键生成策略
    private String userdgthemeid;
    private String userdgthemename;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[表格编号]
     *  @param datagridid
     */
    public void setDatagridid(String datagridid){
        if(StringUtils.isEmpty(datagridid))
            datagridid=null;
        this.datagridid = datagridid;
        this.set("datagrididdirtyflag",true);
    }
    /**
     *  获取属性值[表格编号]
     */
    public String getDatagridid(){
        return this.datagridid;
    }
    /**
     *  重置属性值[表格编号]
     */
    public void resetDatagridid(){
        this.set("datagrididdirtyflag",false);
        this.datagridid = null;
    }
    /**
     *  设置属性值[表格主题模型]
     *  @param dgthememodel
     */
    public void setDgthememodel(String dgthememodel){
        if(StringUtils.isEmpty(dgthememodel))
            dgthememodel=null;
        this.dgthememodel = dgthememodel;
        this.set("dgthememodeldirtyflag",true);
    }
    /**
     *  获取属性值[表格主题模型]
     */
    public String getDgthememodel(){
        return this.dgthememodel;
    }
    /**
     *  重置属性值[表格主题模型]
     */
    public void resetDgthememodel(){
        this.set("dgthememodeldirtyflag",false);
        this.dgthememodel = null;
    }
    /**
     *  设置属性值[人员编号]
     *  @param personid
     */
    public void setPersonid(String personid){
        if(StringUtils.isEmpty(personid))
            personid=null;
        this.personid = personid;
        this.set("personiddirtyflag",true);
    }
    /**
     *  获取属性值[人员编号]
     */
    public String getPersonid(){
        return this.personid;
    }
    /**
     *  重置属性值[人员编号]
     */
    public void resetPersonid(){
        this.set("personiddirtyflag",false);
        this.personid = null;
    }
    /**
     *  设置属性值[项目编号]
     *  @param projectid
     */
    public void setProjectid(String projectid){
        if(StringUtils.isEmpty(projectid))
            projectid=null;
        this.projectid = projectid;
        this.set("projectiddirtyflag",true);
    }
    /**
     *  获取属性值[项目编号]
     */
    public String getProjectid(){
        return this.projectid;
    }
    /**
     *  重置属性值[项目编号]
     */
    public void resetProjectid(){
        this.set("projectiddirtyflag",false);
        this.projectid = null;
    }
    /**
     *  设置属性值[RESERVER]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[RESERVER]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[RESERVER]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[RESERVER2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[RESERVER2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[RESERVER2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[RESERVER3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[RESERVER3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[RESERVER3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[表格列定义标识]
     *  @param userdgthemeid
     */
    public void setUserdgthemeid(String userdgthemeid){
        if(StringUtils.isEmpty(userdgthemeid))
            userdgthemeid=null;
        this.userdgthemeid = userdgthemeid;
        this.set("userdgthemeiddirtyflag",true);
    }
    /**
     *  获取属性值[表格列定义标识]
     */
    public String getUserdgthemeid(){
        return this.userdgthemeid;
    }
    /**
     *  重置属性值[表格列定义标识]
     */
    public void resetUserdgthemeid(){
        this.set("userdgthemeiddirtyflag",false);
        this.userdgthemeid = null;
    }
    /**
     *  设置属性值[表格列定义名称]
     *  @param userdgthemename
     */
    public void setUserdgthemename(String userdgthemename){
        if(StringUtils.isEmpty(userdgthemename))
            userdgthemename=null;
        this.userdgthemename = userdgthemename;
        this.set("userdgthemenamedirtyflag",true);
    }
    /**
     *  获取属性值[表格列定义名称]
     */
    public String getUserdgthemename(){
        return this.userdgthemename;
    }
    /**
     *  重置属性值[表格列定义名称]
     */
    public void resetUserdgthemename(){
        this.set("userdgthemenamedirtyflag",false);
        this.userdgthemename = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetDatagridid();
        resetDgthememodel();
        resetPersonid();
        resetProjectid();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetUpdatedate();
        resetUpdateman();
        resetUserdgthemeid();
        resetUserdgthemename();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public UserDGTheme copyTo(UserDGTheme targetEntity)
	{
		BeanCopier copier=BeanCopier.create(UserDGTheme.class, UserDGTheme.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetUserdgthemeid();
		return targetEntity;
	}
}